## macaulay2 1.23+ds

=== CMakeLists.txt ===
###############################################################################
## CMake is a cross-platform system for generating build environments using
## native tools such as Make and Ninja or IDEs such as Xcode and Visual Studio.
##
## See INSTALL-CMake.md for a comprehensive guide to building M2 using CMake.
## Take a look at cmake/configure.cmake for a list of options
## and read cmake/check-libraries.cmake for a list of requirements.
##
## Short instructions:
##  1. cmake -GNinja -S . -B BUILD/cmake
##  2. cmake --build BUILD/cmake --target build-libraries build-programs
##  2. cmake --build BUILD/cmake --target M2-engine M2-binary M2-core M2-emacs
##  2. cmake --build BUILD/cmake --target install-packages check-packages
##  6. cmake --install BUILD/cmake
###############################################################################

## Requires CMake version 3.15 and is tested with 3.19
cmake_minimum_required(VERSION 3.15...3.19)
cmake_policy(VERSION 3.14)

## Use the C++20 standard
set(CMAKE_CXX_STANDARD 17)
## Use the C11 (C0X) standard
set(CMAKE_C_STANDARD 11)

###############################################################################
## Set the default build configuration
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

## Guard against in-source builds
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not allowed. Delete CMakeFiles and CMakeCache.txt from the source directory.")
endif()
if(EXISTS ${CMAKE_SOURCE_DIR}/include/M2/config.h)
  message(FATAL_ERROR "In-source build artifacts detected. Run `make clean distclean` from the source directory.")
endif()

## Enable support for folders in IDEs
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

## Enable ccache or distcc acceleration with Makefile and Ninja
# Note: libraries and programs aren't using ccache this way.
find_program(CCACHE ccache)
if(CCACHE)
  # run ccache -s to get the CCache statistics
  set(CMAKE_C_COMPILER_LAUNCHER "${CCACHE}")
  set(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE}")
endif()

###############################################################################
## Source of truth for project version
file(STRINGS VERSION VERSION)

## Set the project name, version, and languages
project(Macaulay2
  VERSION	${VERSION}
  DESCRIPTION	"A software system for algebraic geometry research"
  HOMEPAGE_URL	http://macaulay2.com # contact: Macaulay2@math.uiuc.edu
  LANGUAGES	C CXX)

###############################################################################
## Set path for CMake modules
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include(prechecks) ## CMake macros for preprocessor checks and linting
include(CTest)     ## CMake module for generating a 'test' target for all unit-tests
include(profiling) ## CMake macros for profiling Macaulay2 code
include(configure) ## CMake script for configuring various variables
include(check-libraries) ## CMake script for checking which libraries exist and which need to be built
include(build-libraries) ## CMake script for downloading, building, and installing external libraries
include(startup) ## CMake script for messy substitutions in Macaulay2/bin/startup.c

###############################################################################
## Configure M2/config.h
configure_file(include/M2/config.h.cmake include/M2/config.h)

###############################################################################
## Kick off the Macaulay2 directory
add_subdirectory(Macaulay2)

###############################################################################

include(packaging) ## CMake script for making distribution packages for Macaulay2

###############################################################################
## This section is temporary hacks! Try to reduce or move them elsewhere.

set(M2_CONTENT "#!/bin/sh\nexec ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2 \"$@\"")
execute_process(
  COMMAND ${CMAKE_COMMAND} -E echo "${M2_CONTENT}"
  OUTPUT_FILE ${CMAKE_BINARY_DIR}/M2)
execute_process(
  COMMAND chmod +x ${CMAKE_BINARY_DIR}/M2)

# Hackish way to set topSrcdir in startup.m2
# FIXME: DELETING THIS CAUSES CONFUSING PATH ERRORS!!!
file(RELATIVE_PATH LIST_FILE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_FILE})
get_filename_component(RELATIVE_SOURCE_DIR ${LIST_FILE} DIRECTORY)
file(GENERATE OUTPUT srcdir CONTENT "${RELATIVE_SOURCE_DIR}/\n")

=== debian/changelog ===
macaulay2 (1.23+ds-2build1) oracular; urgency=medium

  * No-change rebuild against libflint19

 -- Simon Chopin <ravi.kant.sharma@canonical.com>  Tue, 14 May 2024 10:38:25 +0200

macaulay2 (1.23+ds-2) unstable; urgency=medium

  * debian/patches/skip-failing-package-tests.patch
    - Skip RInterface tests that are failing on riscv64 and loongarch64.

 -- Doug Torrance <dtorrance@debian.org>  Thu, 04 Apr 2024 23:18:37 -0400

macaulay2 (1.23+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Move normaliz from Recommends to Depends; now loaded on startup.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 20 Mar 2024 06:18:28 -0400

macaulay2 (1.23~rc1+ds-1) experimental; urgency=medium

  * New upstream release candidate.
  * debian/control
    - Remove libatomic-ops-dev from Build-Depends; no longer necessary.
    - Replace deprecated pkg-config with pkgconf in Build-Depends.
    - Add r-base to Build-depends and Suggests.
  * debian/copyright
    - Bump my copyright years
    - Remove atomic_ops-related files.
    - Add license info for new packages.
    - Update Files for documentation moved from Macaulay2Doc to Varieties
      package.
  * debian/macaulay2-common.lintian-overrides
    - Shorten override comment to avoid wrapping in terminal.
    - Add new package-contains-documentation-outside-user-share-doc
      overrides.
  * debian/patches
    - Refresh patches for new upstream release.
    - Remove patches applied upstream:
      + boost-thread.patch
      + flint3.patch
      + python-3.12.patch
  * debian/patches/no-version-select.patch
    - New package; disable version-select dropdown menu in html
      documentation.
  * debian/patches/skip-failing-package-tests.patch
    - Skip some Topcom and Triangulations package tests that frequently
      fail on arm and s390x machines.
  * debian/patches/topcom-memopt.patch
    - Add --memopt option in several more calls to TOPCOM.
  * debian/patches/use-dh-elpa.patch
    - Rewrite setupEmacs so M2 major modes will properly load even if Emacs
      isn't the Debian-packaged version.
  * debian/rules
    - Exclude .uuid files from dh_linktree; their presence was
      occasionally causing build failures.
  * debian/scripts/Debian.m2
    - Add ExampleFreeResolutions package to list of packages to skip in
      missingPackages function.
  * debian/README.Debian
    - Add r-base to "Suggested packages" section.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 02 Mar 2024 21:43:15 -0500

macaulay2 (1.22+ds-6) unstable; urgency=medium

  * debian/copyright
    - Update copyright years for gmpy2 code.
  * debian/patches/python-3.12.patch
    - New patch; add support for Python 3.12 (Closes:  #1061313).

 -- Doug Torrance <dtorrance@debian.org>  Mon, 22 Jan 2024 10:17:56 -0500

macaulay2 (1.22+ds-5) unstable; urgency=medium

  * debian/patches/boost-thread.patch
    - New patch; disable thread safety for Boost if no atomic ints or
      std::mutex. Fixes armel build with Boost 1.83.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 19 Dec 2023 17:26:50 -0500

=== debian/control ===
Source: macaulay2
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: 4ti2,
               bison,
               cohomcalg,
               coinor-csdp,
               debhelper-compat (= 13),
               dh-linktree,
               fflas-ffpack,
               flex,
               gfan,
               install-info,
               libboost-dev,
               libboost-math-dev,
               libboost-regex-dev,
               libboost-stacktrace-dev,
               libcdd-dev,
               libeigen3-dev,
               libffi-dev,
               libflint-dev (>= 2.6.0~),
               libfrobby-dev,
               libgc-dev,
               libgdbm-dev,
               libglpk-dev,
               libgtest-dev,
               liblapack-dev,
               liblzma-dev,
               libmathic-dev,
               libmathicgb-dev (>= 1.0~git20220225~),
               libmemtailor-dev,
               libmpfi-dev,
               libmpfr-dev,
               libmps-dev,
               libntl-dev,
               libreadline-dev,
               libsingular4-dev (>= 1:4.2.0~),
               libtbb-dev,
               libxml2-dev,
               lrslib,
               lsb-release,
               nauty,
               normaliz,
               pkgconf,
               python3-dev <!nopython>,
               r-base,
               singular-data,
               time,
               topcom
Build-Depends-Indep: dh-sequence-elpa,
                     faketime,
                     fonts-glyphicons-halflings,
                     fonts-katex,
                     gdbmtool,
                     jdupes,
                     libjs-bootsidemenu,
                     libjs-bootstrap,
                     libjs-d3,
                     libjs-jquery (>= 3.5.1+dfsg+~3.5.5-4),
                     libjs-katex (>= 0.11.0~),
                     libjs-nouislider,
                     libjs-three,
                     libjs-underscore,
                     node-clipboard,
                     node-css-loader <!nodoc>,
                     node-import-local <!nodoc>,
                     node-interpret <!nodoc>,
                     node-prismjs <!nodoc>,
                     node-rechoir <!nodoc>,
                     node-style-loader <!nodoc>,
                     npm <!nodoc>,
                     pkg-js-tools <!nodoc>,
                     webpack <!nodoc>
Standards-Version: 4.6.2
Homepage: http://macaulay2.com
Vcs-Browser: https://salsa.debian.org/math-team/macaulay2
Vcs-Git: https://salsa.debian.org/math-team/macaulay2.git
Rules-Requires-Root: no

Package: macaulay2
Architecture: any
Depends: gdbmtool,
         macaulay2-common (= ${source:Version}),
         normaliz,
         singular-data,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: 4ti2,
            cohomcalg,
            coinor-csdp,
            elpa-macaulay2 (= ${source:Version}),
            gfan,
            info,
            lrslib,
            nauty,
            texlive-latex-base,
            topcom,
            www-browser,
            xdg-utils,
            xterm
Suggests: bergman,
          dot2tex,
          fig2dev,
          graphviz,
          pdf-viewer,
          phcpack,
          polymake,
          r-base,
          qepcad,
          sdpa
Description: Software system for algebraic geometry research
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture dependent portion of Macaulay2.

Package: macaulay2-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Software system for algebraic geometry research (common files)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture independent portion of Macaulay2, and is
 normally installed automatically when one of the architecture dependent
 packages is installed.

Package: elpa-macaulay2
Architecture: all
Multi-Arch: foreign
Section: editors
Depends: ${elpa:Depends}, ${misc:Depends}
Recommends: emacs
Description: Software system for algebraic geometry research (Emacs package)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the modes for running Macaulay2 within Emacs and
 editing Macaulay2 code.
